#ifndef CDisplays_H
#define CDisplays_H

struct grCanvas;


enum INPUT_MODE { 
	MULTI_SELECT, 
	CANVAS_PAN, 
	NONE, 
	RESIZE_RAMP, 

	//for parcoord
	RESIZE_BRUSH_TOP, 
	RESIZE_BRUSH_BOTTOM, 
	TRANSLATE_BRUSH, 
	INCREASE_AXES_INTERVAL, 
	DECREASE_AXES_INTERVAL,

	//for scatter
	RESIZE_BRUSH, 
	MOVE_BRUSH, 
	INCREASE_PLOT_SIZE, 
	DECREASE_PLOT_SIZE
};


class CDisplay
{
protected:
	grCanvas *canvas;
	int dims;
    int all_dims;

	bool xor_needs_undo;
	INPUT_MODE input_mode;

public:
	CDisplay();
	~CDisplay();
	
    void SetCanvas(grCanvas *canvas);
	virtual bool TestDimensionality();

	void CanvasDraw();
	void CanvasInputKeyPress(int key);
	void CanvasInputKeyRelease(int key);
	void CanvasInputMouseMotion(int x, int y);
	void CanvasInputButtonPress(int button, int x, int y);
	void CanvasInputButtonRelease(int button, int x, int y);
    virtual void Reshape();


protected:
    virtual void Draw();
    virtual void PrepareCanvas();
    
    virtual void InputMouseMotion(int x, int y);
    virtual void InputButtonPress(int button, int x, int y);
    virtual void InputButtonRelease(int button, int x, int y);
    virtual void InputKeyPress(int key);
    virtual void InputKeyRelease(int key);

};

#endif

